
#import "RulePanel.h"
#import "nxlcau5h.h"
#import <string.h>
#import <math.h>
#import <time.h>
#import "rec.h"

extern char arule[DS], arr1[AL], arr2[AL], arr3[AL];
extern birular binrule;
extern char ascrule[KK][KK];
extern char auxrule[KK][KK];
extern char gf5rule[13];		/* coefficients of GF5 rule	*/
extern char ttrule[TS];
extern char tarule[TS];
extern char strule[KK][SS];
extern char sarule[KK][SS];

extern  struct  fptbl  dtbl[];
extern  Inst    xprg[][XLEN];
extern  char	idef[][30];

int longwolftoasc(char *c);

int permu[RSYM/2][KK] = {
        {0,1,2,3,4},
        {1,2,3,4,0},
        {2,3,4,0,1},
        {3,4,0,1,2},
        {4,0,1,2,3},
        {0,2,3,4,1},
        {0,3,4,1,2},
        {0,4,1,2,3},      
        {1,3,4,0,2},
        {1,4,0,2,3},
        {1,0,2,3,4},
        {2,4,0,1,3},
        {2,0,1,3,4},
        {2,1,3,4,0},
        {3,0,1,2,4},
        {3,1,2,4,0},
        {3,2,4,0,1},
        {4,1,2,3,0},
        {4,2,3,0,1},
        {4,3,0,1,2},
        {0,1,3,4,2},
        {0,1,4,2,3},
        {1,2,4,0,3},
        {1,2,0,3,4},
        {2,3,0,1,4},
        {2,3,1,4,0},
        {3,4,1,2,0},
        {3,4,2,0,1},
        {4,0,2,3,1},
        {4,0,3,1,2},
        {0,2,4,1,3},
        {0,2,1,3,4},
        {0,3,1,2,4},
        {0,3,2,4,1},
        {0,4,2,3,1},
        {0,4,3,1,2},
        {1,3,0,2,4},
        {1,3,2,4,0},
        {1,4,2,3,0},
        {1,4,3,0,2},
        {1,0,3,4,2},
        {1,0,4,2,3},
        {2,4,1,3,0},
        {2,4,3,0,1},
        {2,0,3,4,1},
        {2,0,4,1,3},
        {2,1,4,0,3},
        {2,1,0,3,4},
        {3,0,2,4,1},
        {3,0,4,1,2},
        {3,1,4,0,2},
        {3,1,0,2,4},
        {3,2,0,1,4},
        {3,2,1,4,0},
        {4,1,3,0,2},
        {4,1,0,2,3},
        {4,2,0,1,3},
        {4,2,1,3,0},
        {4,3,1,2,0},
        {4,3,2,0,1},
        {0,1,2,4,3},
        {1,2,3,0,4},
        {2,3,4,1,0},
        {3,4,0,2,1},
        {4,0,1,3,2},
        {0,2,3,1,4},
        {0,3,4,2,1},
        {0,4,1,3,2},   
        {1,3,4,2,0},
        {1,4,0,3,2},
        {1,0,2,4,3},
        {2,4,0,3,1},
        {2,0,1,4,3},
        {2,1,3,0,4},
        {3,0,1,4,2},
        {3,1,2,0,4},
        {3,2,4,1,0},
        {4,1,2,0,3},
        {4,2,3,1,0},
        {4,3,0,2,1},
        {0,1,3,2,4},
        {0,1,4,3,2},
        {1,2,4,3,0},
        {1,2,0,4,3},
        {2,3,0,4,1},
        {2,3,1,0,4},
        {3,4,1,0,2},
        {3,4,2,1,0},
        {4,0,2,1,3},
        {4,0,3,2,1},
        {0,2,4,3,1},
        {0,2,1,4,3},
        {0,3,1,4,2},
        {0,3,2,1,4},
        {0,4,2,1,3},
        {0,4,3,2,1},
        {1,3,0,4,2},
        {1,3,2,0,4},
        {1,4,2,0,3},
        {1,4,3,2,0},
        {1,0,3,2,4},
        {1,0,4,3,2},
        {2,4,1,0,3},
        {2,4,3,1,0},
        {2,0,3,1,4},
        {2,0,4,3,1},
        {2,1,4,3,0},
        {2,1,0,4,3},
        {3,0,2,1,4},
        {3,0,4,2,1},
        {3,1,4,2,0},
        {3,1,0,4,2},
        {3,2,0,4,1},
        {3,2,1,0,4},
        {4,1,3,2,0},
        {4,1,0,3,2},
        {4,2,0,3,1},
        {4,2,1,0,3},
        {4,3,1,0,2},
        {4,3,2,1,0}};

/* ........................*/

int     allperm(char wnum[][WNML], char ii[][KK][KK], char ru[KK][KK]);
void    asctobin();
void	asczero();
void	auxzero();
void    bincopy(birular *rz, birular *rx); 
void    binprint(birular *rz);
void    binprod(birular *rz, birular *rx, birular *ry);  
void    binsum(birular *rz, birular *rx, birular *ry);
void    bintoasc();
void    chrucopy(char ii[KK][KK], char jj[KK][KK], int c);
void    clumin(char *c);
int     cyy(int i);
int     czz(int i);
int     fli(int i);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
int     istot();
int     isstot();
int     longwolftoasc(char *c);
void    nutowo1(int i);
void    nutowo2(int i);
void    oxtoasc(char *r);
int     permut(int k, int n);
void    ptedbrul(birular *pr, birular *br, int k);
void    putionj(int i, int j);
int     ran2of4(int a, int b);
int     ran3of4(int a, int b, int c);
void    ranrul();
void    ranblin(double p0, double p1, double p2, double p3, double p4);
void    ranvachrul(char *c);
void    rule4h();
void    runowows(char x[2][2], int n);
void	sttoasc();
void    stzero();
void	totoasc();
int     totonu(int i);
void    ttzero();
int     vecperm(int ii[KK], int n);
int     wolbin(int i, int j);
void    wru(char *c);
void    wrru(char *c, char ru[KK][KK]);
void	xtoasc(int n);
int     ycc(int i);
int     zcc(int i);

char    xr[DS] = "1212201012212000001010001";
char    xp[DS] = "5323372423353614112526112";
char    xq[DS] = "1464476764474257556767556";


@implementation RulePanel

/* - - - - - S P E C I A L   R U L E   B O X   M A N A G E M E N T - - - - - */

- loadSpecialRule:sender {char *ch;
  ch=[[sender selectedCell] title];
  if (strcmp(ch,"appIcon")==0)     [self loadLowerPanel: [NXApp appIcon]];
  if (strcmp(ch,"arithmetic")==0)  [self loadLowerPanel: arithmRuleBox];
  if (strcmp(ch,"equivalence")==0) [self loadLowerPanel: equivRuleBox];
//  if (strcmp(ch,"eater")==0)       [self loadLowerPanel: eaterRuleBox];
  if (strcmp(ch,"clannish")==0)    [self loadLowerPanel: subsetRuleBox];
  if (strcmp(ch,"permutation")==0) [self loadLowerPanel: pmutRuleBox];
//  if (strcmp(ch,"reversible")==0)  [self loadLowerPanel: fredknRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox {
  NXRect bxRect, loRect;
  id cv;
cv=[thisRuleBox contentView];
printf("thisRuleBox title = %d\n",[[cv subviews] count]);
  nowSpesh=thisRuleBox;
  [specBigBox getFrame: &bxRect];
  [thisRuleBox getFrame: &loRect];
  [specLilBox setContentView: cv];
  loRect.origin.x=bxRect.origin.x+(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=bxRect.origin.y+(bxRect.size.height-loRect.size.height)/2.0;
  [specLilBox setFrame: &loRect];
  [specBigBox display];
  [specLilBox display];
return self;
}

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow) nowBox=ruleBox;
  if (sender==speshPanel) nowBox=nowSpesh;
  if (sender==infoPanel)  nowBox=sender;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- protectGenRule:sender
{int i, j, k, i0, i1,l,m;
  i=j=[sender selectedCol];
  printf("columna seleccionada i=%d  j=%d:\n",i,j);
  i1=i%KK; i/=KK;
  printf(" i1=%d  i=%d:\n",i1,i);
  i0=i%KK; i/=KK;
  printf("i0=%d  i=%d:",i0,i);
  for (l=0; l<KK; l++) for (m=0; m<KK; m++) printf("auxrule[%d][%d]=%d\n",l,m,auxrule[l][m]);
  k=auxrule[i0][i1];
  printf("k=auxrule[%d][%d]=%d\n",i0,i1,auxrule[i0][i1]);
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1]=!k;
  printf("auxrule[%d][%d]=%d=!k\n",i0,i1,auxrule[i0][i1]);
return self;
}

- relatedRule:sender
{
char    ii[RSYM][KK][KK], wnum[RSYM][WNML], c[WNML], *titl;
int     j, k, l, jj[KK];
  l=allperm(wnum,ii,ascrule);
printf("la minima regla es %d\n",l);
/*  for (j=0;j<RSYM;j++) printf("s%/n",wnum[j]); */
  titl=[[sender selectedCell] title];
       if (strcmp(titl,"cycle  5")==0)  k=1;
  else if (strcmp(titl,"cycle  4")==0)  k=5; 
  else if (strcmp(titl,"cycle  3")==0)  k=20; 
  else if (strcmp(titl,"cycle  2")==0)  k=60; 
  else if (strcmp(titl,"reflected")==0) k=120;
  else if (strcmp(titl,"cluster")==0)   k=RSYM;
  else if (strcmp(titl,"flip")==0)      k=60;
  else if (strcmp(titl,"least")==0)     k=l;
 /* es "ele" no "uno" */
  else  				k=0;
  if (k==RSYM) {
    clumin(c);
    longwolftoasc(c);
    [self setAllRules: self];
    [self setAllImages: self];
    return self;
    }
  chrucopy(ascrule,ii[k],'w');
  [self setAllRules: self];
  [self setAllImages: self];
  if ([changeLine state]) {
    l=vecperm(jj,k);
    for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
    if (l) {
      for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
      for (j=0; j<AL; j++) arr1[j]=arr2[j];
      }
    }
   printf ("related rules\n");
   for (k=0; k<3; k++) printf("%s\n",wnum[k]);
return self;
}

/*  generate a table of permutations of a given rule      */
/*  and report the index of the rule with smallest wru    */
/*  wn - array to be filled with WNML-1-letter wolfram numbers */
/*  ii - array to be filled with ascrule symmetry images  */
/*  ru - reference KK8KK table - e.g. ascrule          */
/*  return value is the index of the least of all these   */
/*  that is, wnum[...] is the number, ii[...] is the rule   */
int allperm(wnum,ii,ru) char wnum[][WNML], ii[][KK][KK], ru[KK][KK]; {
int k, l,j,i,n;
   chrucopy(ii[0], ru, 'w');		 /* (0 1 2 3 4) identity */
 /* cyclic permutation n (0 1 2 3 4) */
   for (i=1; i<5; i++) chrucopy(ii[i],ii[i-1], 'y');
 /* cyclic permutation n-1 (1 2 3 4)*/
   for (i=5; i<20; i++) chrucopy(ii[i], ii[i-KK], 'x');
 /* cyclic permutation n-2 (2 3 4)*/
   for (i=20; i<60; i++) chrucopy(ii[i], ii[i-20], 'v');
/* cyclic permutation n-3 (transpose) (3 4) (2 3).. */
   for (i=60; i<120; i++) chrucopy(ii[i],ii[i-60], 't');
/* Reflexion */
for (i=RSYM/2; i<RSYM; i++) chrucopy(ii[i],ii[i-RSYM/2],'r'); 

    for (k=0, l=0; k<240; k++) {
     wrru(wnum[k],ii[k]); 
   /* printf("%s   ---->%s\n",wnum[k],wnum[l]); */
    if (strcmp(wnum[k],wnum[l]) < 0) l=k;
    }
return l;
//printf("%d\n",l);
}

/* fill a KK-vector ii with inverse permutation #n of its indices  */
/* inverse is because this will be used to generate configurations */
/* return TRUE if there was a reflection of the neighborhood       */
int vecperm(ii,n) int ii[KK], n;
{int i, k, l;
  l=!(n<RSYM/2); k=(l?n-(RSYM/2):n);
   for (i=0; i<KK; i++) ii[i]=permu[k][i];
  return l;
}

/* copy a related (character) rule */
/* c = w - no change               */
/* c = y - cyclic permutation      */
/* c = r - reflected               */
/* c = t - transpose            */

void chrucopy(ii,jj,c) char ii[KK][KK], jj[KK][KK], c; {
int i0, i1;
  switch (c) {
    case 'w':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
     	ii[i0][i1]=jj[i0][i1];
      break;
    case 'y':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
     	ii[i0][i1]=ycc(jj[cyy(i0)][cyy(i1)]);
      break;
    case 'x':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
     	ii[i0][i1]=xcc(jj[cxx(i0)][cxx(i1)]);
      break;
    case 'v':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
     	ii[i0][i1]=vcc(jj[cvv(i0)][cvv(i1)]);
      break;
    case 'r':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
     	ii[i0][i1]=jj[i1][i0];
      break;
    case 't':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      	ii[i0][i1]=fli(jj[fli(i0)][fli(i1)]);
      break;
    default: break;}
}

int fli(i) int i; {switch (i) {
	case '0': return '0';
        case '1': return '1';
        case '2': return '2';
	case '3': return '4'; 
	case '4': return '3';
        case  0 : return  0 ;
        case  1 : return  1 ;
        case  2 : return  2 ;
	case  3 : return  4 ; 
	case  4 : return  3 ;
	default:  return '0';}
}

int cyy(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '3';
        case '3': return '4';
        case '4': return '0';
	case 0: return 1;
	case 1: return 2; 
	case 2: return 3;
        case 3: return 4; 
	case 4: return 0;
	default:  return '0';}
}

int ycc(i) int i; {switch (i) {
	case '0': return '4';
	case '1': return '0'; 
	case '2': return '1';
        case '3': return '2';
        case '4': return '3';
	case 0: return 4;
	case 1: return 0; 
	case 2: return 1;
        case 3: return 2; 
	case 4: return 3;
	default:  return '0';}
}

int cxx(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '2'; 
	case '2': return '3';
        case '3': return '4';
        case '4': return '1';
	case 0: return 0;
	case 1: return 2; 
	case 2: return 3;
        case 3: return 4; 
	case 4: return 1;
	default:  return '0';}
}

int xcc(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '4'; 
	case '2': return '1';
        case '3': return '2';
        case '4': return '3';
	case 0: return 0;
	case 1: return 4; 
	case 2: return 1;
        case 3: return 2; 
	case 4: return 3;
	default:  return '0';}
}

int cvv(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '1'; 
	case '2': return '3';
        case '3': return '4';
        case '4': return '2';
	case 0: return 0;
	case 1: return 1; 
	case 2: return 3;
        case 3: return 4; 
	case 4: return 2;
	default:  return '0';}
}

int vcc(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '1'; 
	case '2': return '4';
        case '3': return '2';
        case '4': return '3';
	case 0: return 0;
	case 1: return 1; 
	case 2: return 4;
        case 3: return 2; 
	case 4: return 3;
	default:  return '0';}
}


/* create the rule defined by the "symmetric rule" panel */
/* - symRule:sender {
int j00, j01, j02, j10, j11, j12, j20, j21, j22;
int i0, i1, i2, j0, j1, r;

j00=[[s00 selectedCell] tag];
j01=[[s01 selectedCell] tag];
j02=[[s02 selectedCell] tag];
j10=[[s10 selectedCell] tag];
j11=[[s11 selectedCell] tag];
j12=[[s12 selectedCell] tag];
j20=[[s20 selectedCell] tag];
j21=[[s21 selectedCell] tag];
j22=[[s22 selectedCell] tag];
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    j0=KK+i1-i0;
    j1=KK+i2-i1;
    r =j00+j0*(j10+j0*j20)+j1*(j01+j1*j20);
    r+=j0*j1*(j11+j0*j21+j1*j12);
    r+=j0*j0*j1*j1*j22;
    switch([[sIncr selectedCell] tag]) {
      case 0: r+=i0; break;
      case 1: r+=i1; break;
      case 2: r+=i2; break;
      case 3: r+=(KK-i0)+(KK-i1); break;
      case 4: r+=(KK-i1)+(KK-i2); break;
      case 5: r+=(KK-i2)+(KK-i0); break;
      case 6: break;
      default: break;}
    ascrule[i2][i1]=r%KK+'0';
    }
  [self setAllRules: self];
  [self setAllImages: self];
  return self;
  } */

- readWRule:sender {char  *c; int l;
     c=[sender stringValue];
     l=strlen(c);
     if(l>WNML-1) {[ruleNumber setStringValue: "exceded"]; return self;}
     if (longwolftoasc(c)) {[self setAllRules: self];
			    [self setAllImages: self];}
        else [ruleNumber setStringValue: "invalid"];
     return self;
   }

int longwolftoasc(char *c) {
char d[WNML], e;
int i, l, n, i0, i1;
  l=strlen(c);
  for (i=0; i<WNML; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'o') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'O') n=e-'A'+10;
    else    return FALSE;
    d[WNML-1-l+i]=n;
    }
  for (i=0, i0=0, i1=0; i<WNML-1; i++) {
    n=d[WNML-2-i];
    ascrule[i0][i1]='0'+n%KK;
    i1++; if (i1>=KK) {i1=0; i0++; if (i0>=KK) return TRUE;}
    ascrule[i0][i1]='0'+n/KK;
    i1++; if (i1>=KK) {i1=0; i0++; if (i0>=KK) return TRUE;}
    }
  return TRUE;
} 

- readSqRule:sender {char ch[WNML]; int i, j;

   for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
	ascrule[i][j] = [[sender cellAt: i: j] intValue] + '0';
   [self setAllRules: self];
   [self setAllImages: self];
   return self;
}

- setRule:sender {char ch[WNML]; int i, ii, j, jj, i0, i1;
   wru(ch);
   [ruleNumber setStringValue: ch];
   ii= [sender selectedRow];
   jj=j= [sender selectedCol];
   i1=j%KK; j/=KK;
   i0=j%KK; j/=KK;
   ascrule[i0][i1]='0'+ii;
   for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
   [[ascru cellAt: ii: jj] setIntValue: YES];
   [self setAllRules: self];
   [self setAllImages: self];
return self;
}

- insertRule:sender {
char c[2];
int  i, j, k;
  i=[sender selectedRow];
  j=[sender selectedCol];
  k=[whichState selectedRow]+'0';
  ascrule[i][j]=k;
  c[0]=k; c[1]=0;
  [[sender selectedCell] setTitle: c];
  [self setAllImages: self];
return self;
}

- resetRuButtons:sender {int i0, i1;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)  {
    [[ruButtons cellAt: i0: i1] setTitle: ""];
    }
  [self readWRule: ruleNumber];
  [self setAllImages: self];
return self;
}

- setAllImages:sender {char ch[WNML]; int i0, i1;
   wru(ch);
  asctobin();
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)  {
    [[sqascru cellAt: i0: i1] setIntValue: binrule.two[i0][i1]];
    }
   wru(ch);
return self;
}

- setAllRules:sender {char ch[WNML]; int i, j, i0, i1; 
   wru(ch);
   [ruleNumber setStringValue: ch];
  asctobin();
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)  {
    j=(KK*i0)+i1;
    for (i=0; i<KK; i++) {
      [[ascru cellAt: i: j] setIntValue: NO];
      if (auxrule[i0][i1]) [[ascru cellAt: i: j] setEnabled: NO];
      if (auxrule[i0][i1]) [[ascru cellAt: i: j] setBordered: NO];
      }
    [[ascru cellAt: binrule.two[i0][i1]: j] setIntValue: YES];
    }
   wru(ch);
   [ruleNumber setStringValue: ch];
   [self nxasfreq];
   if      (istot()==1) {asctotot(); [self setTotRules: self];}
      else [totlRef setStringValue: " "];
   [self showProbability: pSliders];
return self;
}

- freeAllRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<DS; j++) 
      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- ranRules:sender {
  granrule();
  asctobin();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- ranPRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

/* for 5-state automata, group the neighborhoods by twos and  */
/* use ASCII letters base 25 - that is, 0-9, A-O.	      */
void wru(c) char *c; {wrru(c,ascrule);}

/* calculate wru from an argument rule */
void wrru(c, ru) char *c, ru[KK][KK]; {
int  i, j, k, l, m;
k=0; j=0; l=0; m=0;
while (TRUE) {
  i=(ru[j][k]-'0')+'0'; 
  k++; if (k>=KK) {k=0; j++;} if (j>=KK) break;
  i+=KK*(ru[j][k]-'0');
  k++; if (k>=KK) {k=0; j++;} if (j>=KK) break;
  if (i>'9') i=i+('A'-':');
    c[WNML-1-l-1]=i;
  l++;
  }
c[0]=i;
c[WNML-1]=0; 
}


/* calculate wru from an argument rule */
void wtoru(c, ru) char *c, ru[KK][KK][KK]; {
int  i, j, k, l, m;
k=0; j=0; l=0; m=0;
while (TRUE) {
  i=(ru[j][k][l]-'0')+'0'; 
  l++; if (l>=KK) {l=0; k++;} if (k>=KK) {k=0; j++;} if (j>=KK) break;
  i+=KK*(ru[j][k][l]-'0');
  l++; if (l>=KK) {l=0; k++;} if (k>=KK) {k=0; j++;} if (j>=KK) break;
  if (i>'9') i=i+('A'-':');
    c[64-1-m-1]=i;
  m++;
  }
c[0]=i;
c[64-1]=0; 
}

/* generate a random rule */
void granrule() {int i, i0, i1;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++){
  i=(random()&0xFF)%KK;
  ascrule[i0][i1]=i+'0';
//  printf("%d",i);
  }
//  printf("\n");
}

/* generate a random protected rule */
void granprule() {int i0, i1,i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
 {
  if (i%8 == 0) j=random(); i++;
  if (auxrule[i0][i1]==0) ascrule[i0][i1]='0'+j%KK;
  j/=KK;
  }
}

- showProbability:sender 
{int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0.0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}


// cambiar a cinco probabilidades estado
- randomLine:sender {double p[KK]; int i;
  for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1],p[2],p[3],p[4]);
return self;
}

- sCellLine:sender {putionj(1,0); return self;}

/* a random configuration with unbiased probabilities */
- uniformLine:sender {ranblin(0.2,0.2,0.2,0.2,0.2); return self;}


/* - - - - - - - - -   D E M O N S T R A T I O N   R U L E   - - - - - - - - */

- setDemo:sender {char ch[WNML];
   wru(ch);
   [ruleNumber setStringValue: ch];
  xtoasc([[sender selectedCell] tag]);
  [self setAllRules: self];
  [self setAllImages: self];
  return self;
}

/* - - - - - - - - - - -    P E R M U T E D   R U L E    - - - - - - - - - - */

- pmutRule: sender 
{int i, j, p[KK], ru[KK][KK];
  p[0]=[pMut0 selectedCol];
  p[1]=[pMut1 selectedCol];
  p[2]=[pMut2 selectedCol];
  p[3]=[pMut3 selectedCol];
  p[4]=[pMut4 selectedCol];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) ru[i][j] = ascrule[p[i]][p[j]]-'0';
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) ascrule[i][j] = p[ru[i][j]]+'0';
  asctobin();
  [self setAllRules:self];
  [self setAllImages: self];
return self;
}

- pmutValue: sender {int i, j, k, p[KK];
  p[0]=[pMut0 selectedCol];
  p[1]=[pMut1 selectedCol];
  p[2]=[pMut2 selectedCol];
  p[3]=[pMut3 selectedCol];
  p[4]=[pMut4 selectedCol];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) {
    k = ascrule[i][j] - '0';
    ascrule[i][j] = p[k] + '0';
    }
  asctobin();
  [self setAllRules:self];
  [self setAllImages: self];
return self;
}

void ptedbrul(pr,br,k) birular *pr, *br; int k; {
int i;
  for (i=0; i<KK*KK; i++) pr->one[i]=permu[k][br->one[i]];
}

/* - - - - - - - - - - - - -   G F ( 5 )   R U L E   - - - - - - - - - - - - */

- setMCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf5rule[t]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setVCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf5rule[t+9]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setSCoeff:sender {int s;
    s=[sender selectedRow];
    gf5rule[12]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- enterGF5Rule:sender
{
//   int i; for (i=0; i<13; i++) printf("%1d ",gf5rule[i]); printf("\n");
    gftoasc();
    [self setAllRules:self];
    [gfWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - -    R E V E R S I B L E    R U L E S   - - - - - - - - - */

/* Seck Tuoh Mora Juan Carlos, May 23, 1997 */

char revlist[RBLNUM][WNML] = {
"4OOIIHCC66500",
"4NOINHCC66500",
"4NJIOHCC66500",
"4NIIOMCC66500",
"4OJDJICC66500",
"4OIDJNCC66500",
"4OJIHHCM66500",
"4NJIMHCM66500",
"4ONIHMCH66500",
"4NNIMMCH66500",
"4OIIHMCM66500",
"4NIIMMCM66500",
"4OIDHNCM66500",
"4ENIHMMH66500",
"4EIIHMMM66500",
"4OIIHCCO66500",
"4NIIMCCO66500",
"4ODIJCCJ66500",
"4NDIOCCJ66500",
"4ONIILCCB6500",
"4ONDILCCG6500",
"4ENIILMCB6500",
"4ONIHLCHB6500",
"4ONDHLCHG6500",
"4ONIIBCEB6500",
"4ONDIBCEG6500",
"4EOIIBMDB6500",
"4ENIIBMEB6500",
"4ONIHBCJB6500",
"4ONDHBCJG6500",
"4OMIILCDB6500",
"4OMDILCDG6500",
"4EMIILMDB6500",
"4OMIHLCIB6500",
"4OMDHLCIG6500",
"4OMDHGCJG6500",
"4NOING7CC6500",
"4NJIOG7CC6500",
"4ONIIL7CC6500",
"4NNINL7CC6500",
"4NIIOL7CC6500",
"4ONDIL7CH6500",
"4NOINB7DC6500",
"4OJIJB7DC6500",
"4NJIOB7DC6500",
"4ONIIB7EC6500",
"4NNINB7EC6500",
"4OIIJB7EC6500",
"4NIIOB7EC6500",
"4ONDIB7EH6500",
"4ENIIB7EE6500",
"4ON8ID7EC6500",
"4ON8IC7EH6500",
"4OM8IN7DC6500",
"4OM8IM7DH6500",
"4ONIIMCB66A00",
"4NNINMCB66A00",
"4NIIOMCB66A00",
"4ONDINCB66A00",
"4OIDJNCB66A00",
"4NNIMMCG66A00",
"4OIIHMCL66A00",
"4NIIMMCL66A00",
"4ONDHNCG66A00",
"4OIDHNCL66A00",
"4ENIHMMG66A00",
"4EIIHMML66A00",
"4ONIICCB66K00",
"4NNINCCB66K00",
"4OIIJCCB66K00",
"4NIIOCCB66K00",
"4OIDJDCB66K00",
"4ENIICMB66K00",
"4EIIJCMB66K00",
"4NNIMCCG66K00",
"4OIIHCCL66K00",
"4NIIMCCL66K00",
"4OIDHDCL66K00",
"4ENIHCMG66K00",
"4EIIHCML66K00",
"4ODIJCCG66K00",
"4NDIOCCG66K00",
"4NDINCCL66K00",
"4ODDJDCG66K00",
"4ODDIDCL66K00",
"4EDIJCMG66K00",
"4EDIICML66K00",
"4NOING7BC6A00",
"4NNINL7BC6A00",
"4NIIOL7BC6A00",
"4NOINB7BC6F00",
"4OJIJB7BC6F00",
"4NNINB7BC6K00",
"4OIIJB7BC6K00",
"4NIIOB7BC6K00",
"4EN88MMBGGA00",
"4EN88CMBGGK00",
"4NHIO67EC6F00",
"4NHIO67DC6K00",
"4NOIMCCI16600",
"4NOING7C26700",
"4EO885MCGGH00",
"4NJ3OG7CC6800",
"4NJ3OG7BC6D00",
"4EO88HMCFG550",
"4EM88HMEFG550",
"4NOING7C067A0",
"4NJIOG7C067A0",
"4NIIOL7C067A0",
"4EO88HMC0G850",
"4OJIJHCB06B50",
"4NJIOHCB06B50",
"4NOING7B06CA0",
"4OJIJG7B06CA0",
"4NJIOG7B06CA0",
"4ONIIL7B06CA0",
"4NNINL7B06CA0",
"4OIIJL7B06CA0",
"4NIIOL7B06CA0",
"4OJIHHCM01660",
"4NJIMHCM01660",
"4ONIHMCH01660",
"4NNIMMCH01660",
"4OIIHMCM01660",
"4NIIMMCM01660",
"4OIDHNCM01660",
"4ENIHMMH01660",
"4EIIHMMM01660",
"4ODIJCCJ01660",
"4NDIOCCJ01660",
"4LNINKC26G70A",
"44M88HM4GG5AA"
};

/* --------------------- B R O W S E R   D E L E G A T E ------------------- */

- (int)browser: sender fillMatrix: matrix inColumn: (int)col {
char ch[48];
int  i, j, k, l, m;
  if (col==0) {
    for (i=0; i<RBLNUM; i++) {
      [matrix addRow];
      [[matrix cellAt: i: 0] setLeaf: YES];
      [[matrix cellAt: i: 0] setLoaded: YES];
      [[matrix cellAt: i: 0] setEnabled: YES];
      sprintf(ch,"%3d: %s",i+1,revlist[i]);
      [[matrix cellAt: i: 0] setStringValue: ch];
      }
    return RBLNUM;
    }
}

/* to distract the single click in a browser double click */
- nhul: sender {char ch[WNML]; int i;
  i=[[sender matrixInColumn: 0] selectedRow];
  [ruleNumber setStringValue: revlist[i]];
  [self readWRule: ruleNumber];
 return self;}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules:self];
    [self setAllImages: self];
    [toWindow setDocEdited:NO];
return self;
}

- readTRule:sender
  {char  *c; int i, j, l, m;
     c=[sender stringValue];
     l=strlen(c); m=YES;
     if(l>TS) {[toRuleNumber setStringValue: "too long"]; return self;}
     for (j=0; j<TS; j++) ttrule[j]='0';
     for (j=0; j<l;  j++) {
       i=c[j];
       if ( i<'0' || i>'4' ) {c[j]='*'; m=NO;}
       }
     if (m) for (j=0; j<l; j++) ttrule[j]=c[j];
       else {[sender display]; return self;}
     totoasc();
     [self setTotRules: self];
     return self;
   }

/* copy ttrule */
void wtrru(c, ru) char *c, ru[TS]; {int  i;
  for (i=0; i<TS; i++) c[i]=ru[i];
  c[TS]=0;
}

- setTotRule:sender {char ch[WNML];
  ttrule[[sender selectedCol]]=[sender selectedRow]+'0';
  [self setTotRules: self];
  wtrru(ch,ttrule);
  [toRuleNumber setStringValue: ch];
  [toWindow setDocEdited:YES];
  return self;
}

- setTotRules:sender {char ch[WNML]; int i, j;
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) {
      [[toascru cellAt: i: j] setIntValue: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setEnabled: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setBordered: NO];
      }
    [[toascru cellAt: ttrule[j]-'0': j] setIntValue: YES];
    }
  if (istot()==1) {
	[totlRef setStringValue: "totalistic"];
	wtrru(ch,ttrule);
	[toRuleNumber setStringValue: ch];
	}
  else {
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
return self;
}

- freeAllTotRules:sender {
int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<TS; j++) 
      [[[toascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroTotRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- ranTRule:sender {char ch[TS+1]; int i, j, k;
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) [[toascru cellAt: i: j] setIntValue: NO];
    k=random()%KK;
    ttrule[j]=k+'0';
    [[toascru cellAt: k: j] setIntValue: YES];
    }
  wtrru(ch,ttrule);
  [toRuleNumber setStringValue: ch];
  [toRuleNumber selectText: self];
  [toWindow setDocEdited:YES];
return self;
}

- ranPTotRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

/* generate a random protected rule */
void granptotrule() {int i0, i1, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++) {
          if (i%8 == 0) j=random();  i++;
  	      if (auxrule[i0][i1]==0) 
		  ascrule[i0][i1]='0'+j%KK;
  j/=KK;
  }
}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

- xenophobic:sender {int i, j;
  for (i=0; i<KK; i++) ascrule[i][i]=i+'0';
  for (i=0; i<KK-1; i++) for (j=i+1; j<KK; j++) 
    switch ([[clanMatrix cellAt: i: j] title][0]) {
    case '0': ascrule[i][j]=i+'0'; ascrule[j][i]=i+'0'; break;
    case '1': ascrule[i][j]=j+'0'; ascrule[j][i]=i+'0'; break;
    case '2': ascrule[i][j]=i+'0'; ascrule[j][i]=j+'0'; break;
    case '3': ascrule[i][j]=j+'0'; ascrule[j][i]=j+'0'; break;
    default: break;}
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- enterPair:sender {char c[2]; 
  c[0] = [clan2h selectedRow]+'0'; c[1]=0;
  [[sender selectedCell] setTitle: c];
return self;
}

- randphobic:sender {char c[2]; int i, j;
  for (i=0; i<KK-1; i++) for (j=i+1; j<KK; j++) {
    c[0] = (random()%4)+'0'; c[1]=0;
    [[clanMatrix cellAt: i: j] setTitle: c];
    }
return self;
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender {int k, n, i0, i1, i2;
    k=[sender intValue];
    if (k>=0 && k <=KK) return self;
    k=[sender tag];
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    switch ([designRef selectedRow]) {
      case 0: k=i0; break;
      case 1: k=i1; break;
      case 2: k=i2; break;
      default: k=0; break;}
    n=[designPrm selectedRow];
    k=permut(k,n);
    [sender setIntValue: k];
return self;
}

- clearDesign:sender {
id  z;
int i;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
 return self;
}

- copyToDesign:sender {
id  z;
int i0, i1, i2;
  z=zeZeZe;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    [z setIntValue: ascrule[i0][i1]-'0'];
    z=[z nextText];
    }    
return self;
}

/*- enterDesign:sender {
int i, k, i0, i1, i2;
id  z;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) {
    k=i;
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    k=[z intValue];
    ascrule[i0][i1]=(k<KK?k:0)+'0';
    auxrule[i0][i1]=(k<KK?1:0);
    }
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}*/

int permut(k,n) int k, n; {
  switch (n) {
    case 0: break;
    case 1: k=(k+1)%KK; break;
    case 2: k=(KK+k-1)%KK; break;
    case 3: if (k==1) k=2; else if (k==2) k=1; break;
    case 4: if (k==2) k=0; else if (k==0) k=2; break;
    case 5: if (k==0) k=1; else if (k==1) k=0; break;
    default: break;}
  return k;
}

void clumin(c) char *c; {
char d[WNML], ii[RSYM][KK][KK], wnum[RSYM][WNML];
int i, j, l;
  wrru(c,ascrule);
  l=allperm(wnum,ii,ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<RSYM/2; i++) {
      chrucopy(ascrule,ii[j],'w');
      asctobin();
      ptedbrul(&binrule,&binrule,i);
      bintoasc();
      wrru(d,ascrule);
      if (strcmp(d,c)<0) strcpy(c,d);
      }
    }
}

/* - - - - - - - - - - - -  T R I V I A   P A N E L  - - - - - - - - - - - - */

/* graph the frequencies of ascrule 		 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */

- nxasfreq {
int    i, j, k, i0, i1, i2;
int    stat[KK], statp[KK][KK];		/* statistic counts */
int    shif[RR];			/* shift counts     */
int    xe;				/* xenofhobic count */
double staf[KK], stapf[KK][KK],t, pp, qq;

xe=0;
pp=1.0/((double)(DS));
qq=pp/((double)KK);
for (i=0; i<RR; i++) shif[i]=0;
for (i=0; i<KK; i++) {stat[i]=0; for (j=0; j<KK; j++) statp[i][j]=0;}
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) {
  j=ascrule[i0][i1]-'0';
  stat[j]++;
  if (j==i0) shif[0]++;    /* left */
  if (j==i1) shif[1]++;    /* rigth */
  if (j==i0 || j==i1 ) xe++;
  for (i2=0; i2<KK; i2++) {
      k=ascrule[i1][i2]-'0';
      statp[j][k]++;
   }
 }

// for (i=0; i<RR; i++) printf("shif[%d]=%d",i,shif[i]);

for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: staf[i]];
for (i=0; i<RR; i++) 
      [[statIndx cellAt: i: 0] setDoubleValue: ((double)shif[i])*pp];
//[statIndx setDoubleValue: ((double)shif[0])*pp at: 0];
//[statIndx setDoubleValue: ((double)shif[1])*pp at: 1];

// for (i=0; i<RR; i++) printf("shif[%d]=%5.3f",i,((double)shif[i])*pp);


for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
[statLamb setDoubleValue: 1.0-staf[0]];
[statEntro setDoubleValue: -t/log((double)KK)];
for (i=0, t=0.0; i<KK; i++) for (j=0; j<KK; j++){
    stapf[i][j]=((double) statp[i][j])*qq;
[[statPairs cellAt: i: j] setDoubleValue: stapf[i][j]];
t+=stapf[i][j]*log(stapf[i][j]);
// printf("statpairs[%d][%d]=%5.3f",i,j,stapf[i][j]);
}
[statPEntro  setDoubleValue: -t/log((double)(KK*KK))];
// ("statPEntro=%5.3f",-t/log((double)(KK*KK)));
[statXeno  setDoubleValue: ((double)(DS-xe))*pp at: 0];
[statXeno  setDoubleValue: ((double)xe)*pp at: 1];
return self;
}


/* ------------  A R I T H M E T I C   C O M B I N A T I O N ------------ */

- arithmCombs: sender {
birular aza, bzb, czc;
  [self readWRule: [twoRules cellAt: 0: 0]];
  asctobin();
  bincopy(&aza, &binrule); 
  binprint(&aza);
  [self readWRule: [twoRules cellAt: 1: 0]];
  asctobin();
  bincopy(&bzb, &binrule);
  binprint(&bzb);
  switch ([sender selectedRow]) {
     case 0: binsum(&czc, &aza, &bzb); break;
     case 1: binprod(&czc, &aza, &bzb); break;
     default: printf("arithCombs\n"); return self;}
  printf("imprime czc\n");
  binprint(&czc);
  bincopy(&binrule,&czc);
  bintoasc();
  [self setAllRules: self];
  [self setAllImages: self];
  binprint(&binrule);
return self;
}

- initTwoRules:sender {char c[12];
   granrule();
   wru(c);
   [[twoRules cellAt: [sender selectedRow]: 0] setStringValue: c];
  return self;
 }

/* copy one binary rule from another */
void bincopy(rz,rx)  birular *rz, *rx;
{int i; for(i=0; i<KK*KK; i++) rz->one[i]=rx->one[i];}

/* fill ascrule from binrule */
void bintoasc()
{int i0, i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    ascrule[i0][i1]=binrule.two[i0][i1]+'0';
}

/* sum two binary rules mod KK */
void binsum(rz, rx, ry) birular *rz, *rx, *ry;
{int i; for(i=0; i<KK*KK; i++)  rz->one[i]=(rx->one[i]+ry->one[i])%KK;}


/* multiply two binary rules mod KK */
void binprod(rz, rx, ry) birular *rz, *rx, *ry;
{int i; for(i=0; i<KK*KK; i++) rz->one[i]=(rx->one[i]*ry->one[i])%KK;}

/* print a binary rule (all 25 numbers) */
void binprint(rz) birular *rz; {int i;
for(i=0; i<KK*KK; i++) printf("%c",rz->one[i]+'0');
printf("\n");
}

/* --------- REC Line from rulePanel -----------*/

- useRECLine:sender {
   [RECPanel makeKeyAndOrderFront: sender];
   [RECValue setSringValue: "*"];
   return self;
}

- runRECLine:sender {
   printf("hello from runRec\n");
   [RECValue setStringValue: " "];
   if (rec([sender stringValue]))
      [RECValue setStringValue: "T"];
     else
      [RECValue setStringValue: "F"];
    return self;
}


@end

/* end RulePanel.m */
